dracut/0144-90crypt-Fixed-crypttab_contains-to-also-work-with-de.patch
Thomas Renninger 054341caad Accepting request 346361 from home:favogt:branches:Base:System
Update to dracut-044 and several cleanups.
Works on tumbleweed standard installation and NFS root.

OBS-URL: https://build.opensuse.org/request/show/346361
OBS-URL: https://build.opensuse.org/package/show/Base:System/dracut?expand=0&rev=244
2015-11-26 11:35:04 +00:00

70 lines
2.9 KiB
Diff

From 7f4dea242398cc369ff3fecd599faa00d81a522c Mon Sep 17 00:00:00 2001
From: Julian Wolf <juwolf@suse.de>
Date: Tue, 19 Aug 2014 16:23:59 +0200
Subject: 90crypt: Fixed crypttab_contains() to also work with device path in
/etc/crypttab
blkid is not available when this function is called, so block_uuid.map is put into
the initrd, mapping block devices from /etc/crypttab to UUIDs.
This fixes a bug where udev rules were created by mistake as crypttab_contains()
returned false for devices specified by path in /etc/crypttab which resulted in
error messages during boot.
Signed-off-by: Julian Wolf <juwolf@suse.de>
---
modules.d/90crypt/crypt-lib.sh | 9 +++++++++
modules.d/90crypt/module-setup.sh | 4 ++++
2 files changed, 13 insertions(+)
Index: dracut-044/modules.d/90crypt/crypt-lib.sh
===================================================================
--- dracut-044.orig/modules.d/90crypt/crypt-lib.sh
+++ dracut-044/modules.d/90crypt/crypt-lib.sh
@@ -16,6 +16,14 @@ crypttab_contains() {
[ "$dev" -ef "$_dev" ] && return 0
done
fi
+ if [ -e /usr/lib/dracut/modules.d/90crypt/block_uuid.map ]; then
+ # search for line starting with $d
+ _line=$(sed -n "\,^$d .*$,{p}" /usr/lib/dracut/modules.d/90crypt/block_uuid.map)
+ [ -z "$_line" ] && continue
+ # get second column with uuid
+ _uuid="$(echo $_line | sed 's,^.* \(.*$\),\1,')"
+ strstr "$_uuid" "${luks##luks-}" && return 0
+ fi
done < /etc/crypttab
fi
return 1
Index: dracut-044/modules.d/90crypt/module-setup.sh
===================================================================
--- dracut-044.orig/modules.d/90crypt/module-setup.sh
+++ dracut-044/modules.d/90crypt/module-setup.sh
@@ -64,6 +64,8 @@ install() {
inst_hook cleanup 30 "$moddir/crypt-cleanup.sh"
fi
+ # Have to use exit here, return value gets ignored in dracut.sh...
+ uuid_map_file=$(mktemp /tmp/dracut.XXXXXXXXXX) || exit 1
if [[ $hostonly ]] && [[ -f /etc/crypttab ]]; then
# filter /etc/crypttab for the devices we need
while read _mapper _dev _rest || [ -n "$_mapper" ]; do
@@ -73,6 +75,8 @@ install() {
[[ $_dev == UUID=* ]] && \
_dev="/dev/disk/by-uuid/${_dev#UUID=}"
+ echo "$_dev $(blkid $_dev -s UUID -o value)" >> $uuid_map_file
+
for _hdev in "${!host_fs_types[@]}"; do
[[ ${host_fs_types[$_hdev]} == "crypto_LUKS" ]] || continue
if [[ $_hdev -ef $_dev ]] || [[ /dev/block/$_hdev -ef $_dev ]]; then
@@ -85,6 +89,8 @@ install() {
fi
inst_simple "$moddir/crypt-lib.sh" "/lib/dracut-crypt-lib.sh"
+ inst_simple $uuid_map_file "/usr/lib/dracut/modules.d/90crypt/block_uuid.map"
+ rm -f $uuid_map_file
if dracut_module_included "systemd"; then
inst_multiple -o \